# ------------------------------------------------------------------------
# C Shell Script for Initializing ESE Backend and Frontend Environment Vars: 
# ------------------------------------------------------------------------
# Initial Version : Yonghyun Hwang 
# Last Modified: Mon May 22 03:40 PM 2007
# 11/03/08 GS added SystemC + clean up

echo "Setting up environment variables for ESE"

setenv ESE_PROJECT_ROOT /opt/ese
setenv ESE_DB_ROOT $ESE_PROJECT_ROOT/db

# locally set variable for 3rd party software (will be propagated)
set ESE_3RD_PARTY_ROOT="/opt/pkg"

# set SystemC references 
setenv ESE_SYSTEMC $ESE_3RD_PARTY_ROOT/systemc-2.2.0
setenv ESE_SYSTEMC_INCS $ESE_SYSTEMC/include
setenv ESE_SYSTEMC_LIBS $ESE_SYSTEMC/lib-linux

# prefix path with ese bin dir
setenv PATH $ESE_PROJECT_ROOT/bin:$PATH

# conditionally prefix ese to library path
set ADD_TO_LD="$ESE_PROJECT_ROOT/lib:$ESE_DB_ROOT/lib"
if ($?LD_LIBRARY_PATH) then
    setenv LD_LIBRARY_PATH ${ADD_TO_LD}:${LD_LIBRARY_PATH}
else
    setenv LD_LIBRARY_PATH $ADD_TO_LD
endif


# support for tlmest needing LLVM 
set ESE_LLVM="$ESE_3RD_PARTY_ROOT/llvm-1.9"

setenv PATH $ESE_LLVM/bin:$PATH
setenv LD_LIBRARY_PATH $ESE_LLVM/lib:$LD_LIBRARY_PATH

# support for tlmest needing LLVM cross compiler 
set ESE_LLVM_GCC="$ESE_3RD_PARTY_ROOT/llvm-gcc-3.4"

setenv PATH $ESE_LLVM_GCC/bin:$PATH
setenv LD_LIBRARY_PATH $ESE_LLVM_GCC/lib:$LD_LIBRARY_PATH

