# ------------------------------------------------------------------------
# Initializing ESE Backend and Frontend Environment Vars: 
# ------------------------------------------------------------------------
# USAGE: "source /opt/ese/bin/setup.sh"
#
# Initial Version : Yonghyun Hwang 
# Last Modified: Thu May 29 16:30:59 PDT 2008
# 11/03/08 GS comments and clean up


if echo $ESE_PROJECT_ROOT | grep 'ese' &> /dev/null ; then
    echo "No need to set up environment variables for ESE. It's already set"
else
    echo "Setting up environment variables for ESE"

    export ESE_PROJECT_ROOT=/opt/ese
    export ESE_DB_ROOT=$ESE_PROJECT_ROOT/db

    # locally set variable for 3rd party software (will be propagated)
    ESE_3RD_PARTY_ROOT=/opt/pkg

    # set SystemC variables 
    export ESE_SYSTEMC=$ESE_3RD_PARTY_ROOT/systemc-2.2.0
    export ESE_SYSTEMC_INCS=$ESE_SYSTEMC/include
    export ESE_SYSTEMC_LIBS=$ESE_SYSTEMC/lib-linux

    # prefix the path with ese 
    export PATH=$ESE_PROJECT_ROOT/bin:$PATH

    # conditionally prefix ese to library path
    ADD_TO_LD=$ESE_PROJECT_ROOT/lib:$ESE_DB_ROOT/lib
    if [ -z "$LD_LIBRARY_PATH" ]; then
        export LD_LIBRARY_PATH=$ADD_TO_LD
    else
        export LD_LIBRARY_PATH=$ADD_TO_LD:$LD_LIBRARY_PATH
    fi 


    # support for tlmest needing LLVM 
    ESE_LLVM=$ESE_3RD_PARTY_ROOT/llvm-1.9

    export PATH=$ESE_LLVM/bin:$PATH
    export LD_LIBRARY_PATH=$ESE_LLVM/lib:$LD_LIBRARY_PATH

    # support for tlmest needing LLVM cross compiler 
    ESE_LLVM_GCC=$ESE_3RD_PARTY_ROOT/llvm-gcc-3.4

    export PATH=$ESE_LLVM_GCC/bin:$PATH
    export LD_LIBRARY_PATH=$ESE_LLVM_GCC/lib:$LD_LIBRARY_PATH

fi
