#ifndef PRIOR_QUEUE_H
#define PRIOR_QUEUE_H

#include <list>
/** Priority Queue
    Lower the value for priority, higher the priority
    e.g. priority '0' is higher than priority '1'
    Please note that it is based on sorted list and therefore sorting is stable */
template <class elemType>
class prior_queue {

 public:
  prior_queue();
  ~prior_queue();

  /** Test whether container is empty */
  inline bool empty(void);

  /** Reture size */
  inline unsigned int size(void);

  /** Access next element. no difference from top */
  elemType & front(void);

  /** Access next element. no difference from fron */
  elemType & top(void);

  /** Put the elemet at the end of the queue no matter what the priro of the elem is */
  void push_back(const elemType & item);

  /** Insert element considering priority */
  void push(const elemType & item);

  /** Delete next item */
  inline void pop(void);

#ifdef PRIOR_QUEUE_DEBUG
  void do_check(void);
#endif

 private:
  elemType dummyElem;
  std::list<elemType> queue;
};

template <class elemType>
prior_queue<elemType>::prior_queue(void) {
  queue.clear();
}

template <class elemType>
prior_queue<elemType>::~prior_queue(void) {
  queue.clear();
}

template <class elemType>
bool prior_queue<elemType>::empty(void) {
  return queue.empty();
}

template <class elemType>
unsigned int prior_queue<elemType>::size(void) {
  return queue.size();
}
template <class elemType>
elemType & prior_queue<elemType>::front(void) {

  if(queue.empty()) {
    return dummyElem;
  } else;

  return queue.front();
}

template <class elemType>
elemType & prior_queue<elemType>::top(void) {

  if(queue.empty()) {
    return dummyElem;
  } else;

  return queue.front();
}

template <class elemType>
void prior_queue<elemType>::push(const elemType & item) {

  typename std::list<elemType>::iterator iter;

  if(queue.empty()) {
    queue.push_front(item);
    return;
  } else ;

  for(iter = queue.begin(); iter != queue.end(); iter++) {
    if(item < *iter) {
      queue.insert(iter, item);
      return;
    } else ;
  }

  if(iter == queue.end()) {
    queue.push_back(item);
  } else ;

}

template <class elemType>
void prior_queue<elemType>::push_back(const elemType & item) {
  queue.push_back(item);
}

template <class elemType>
void prior_queue<elemType>::pop(void) {
  if(queue.empty()) return;
  else queue.pop_front();
}

#ifdef PRIOR_QUEUE_DEBUG
void prior_queue<elemType>::do_check(void) {
  std::cout << "Size of queue is " << queue.size() << std::endl;
}
#endif

#endif // end of PRIOR_QUEUE_H
