#ifndef RTOS_LAT_H
#define RTOS_LAT_H

namespace ese_rtos {

  struct RTOS_Conf;

  class RTOS_Lat {

    friend class RTOS_Stats;

  public:
    RTOS_Lat(const RTOS_Conf & conf);
    virtual ~RTOS_Lat() {}

    virtual unsigned int get_send_lat(const unsigned int & numOfBytes) = 0;
    virtual unsigned int get_recv_lat(const unsigned int & numOfBytes) = 0;

  protected:
    unsigned int semPLat, semVLat;
    unsigned int contextSwitchLat;
    unsigned int sharedMemReadLat, sharedMemWriteLat;

    //unsigned int semTakeLat, semGiveLat;
    //unsigned int memcpyLat;
    //unsigned int cxtSaveLat, cxtRestoreLat;
    unsigned int ipcSendLat, ipcRecvLat;
    unsigned int schedLat;
    unsigned int intrHandleLat;
  };

  class XilkernelLat : public RTOS_Lat {

  public:
  XilkernelLat(const RTOS_Conf & conf) : RTOS_Lat(conf) {
      init(conf);
    }
    ~XilkernelLat() {}

    // for now... only dh but, later.. more
    // therefore, we need function ptr!!! refer to set_scheduler something
    unsigned int get_send_lat(const unsigned int & numOfBytes);
    unsigned int get_recv_lat(const unsigned int & numOfBytes);

  private:
    void init(const RTOS_Conf & conf);
  };

  class EmptyRTOS : public RTOS_Lat {

  public:
  EmptyRTOS(const RTOS_Conf & conf) : RTOS_Lat(conf) {
      init(conf);
    }
    ~EmptyRTOS() {}

    unsigned int get_send_lat(const unsigned int & numOfBytes) {return 0;}
    unsigned int get_recv_lat(const unsigned int & numOfBytes) {return 0;}

  private:
    void init(const RTOS_Conf & conf) {}
  };



}
#endif
