#!/usr/bin/python

import sys, os
pathname = os.path.dirname(sys.argv[0])
cpath = os.path.abspath(pathname)
sys.path.append(os.environ['ESE_PROJECT_ROOT']+"/lib/python2.3/site-packages") 

import esexml

d = esexml.design() # this is variable instantiation

d.loadFromDisk(cpath+"/jpeg_mpd_platform_partial.eds")
d.set_design_name("jpeg_mpd_platform_demo")

d.addPE("CPU3","PROCESSOR","MICROBLAZE",0)
d.addPE("CPU4","PROCESSOR","MICROBLAZE",0)

p = d.getPE("CPU3")
p.addPort("CPU3_PORT")
d.addConn("CPU3","CPU3_PORT","M","OPB0")

p.addProc("zigzag")
proc = p.getProc("zigzag")
clist = esexml.eseCharList()
cname = cpath+"/jpeg_srcs/zigzag.c"
clist.append(cname)
cname = cpath+"/jpeg_srcs/Zigzag_aux.c"
clist.append(cname)
proc.add_cfiles(clist)
hlist = esexml.eseCharList()
hname = cpath+"/jpeg_srcs/Zigzag_aux.h"
hlist.append(hname)
proc.add_hfiles(hlist)
proc.addInterface("q2z_if",esexml.ESE_FIFO_CH_BR)
intf = proc.getInterface("q2z_if")
intf.setTypeValue(esexml.ESE_FIFO_CH_BR,"recv_q2z")
proc.addInterface("z2h_if",esexml.ESE_FIFO_CH_BW)
intf = proc.getInterface("z2h_if")
intf.setTypeValue(esexml.ESE_FIFO_CH_BW,"send_z2h")

p = d.getPE("CPU4")
p.addPort("CPU4_PORT")
d.addConn("CPU4","CPU4_PORT","M","OPB0")

p.addProc("huffencode")
proc = p.getProc("huffencode")
clist = esexml.eseCharList()
cname = cpath+"/jpeg_srcs/huffencode.c"
clist.append(cname)
cname = cpath+"/jpeg_srcs/HuffEncode_aux.c"
clist.append(cname)
proc.add_cfiles(clist)
hlist = esexml.eseCharList()
hname = cpath+"/jpeg_srcs/HuffEncode_aux.h"
hlist.append(hname)
proc.add_hfiles(hlist)
proc.addInterface("z2h_if",esexml.ESE_FIFO_CH_BR)
intf = proc.getInterface("z2h_if")
intf.setTypeValue(esexml.ESE_FIFO_CH_BR,"recv_z2h")

l = d.display_chfifo_mapping_types("quantize","zigzag")
i = l.first()
d.add_chfifo("q2z", "CPU2", "quantize", "CPU3", "zigzag")
ch = d.get_chfifo("q2z")
ch.set_writer_interface("q2z_if")
ch.set_reader_interface("q2z_if")
ch.set_size("256")
rt = d.find_routes_chfifo("quantize","zigzag",i)
d.set_chfifo_route("q2z",rt,i)

l = d.display_chfifo_mapping_types("zigzag","huffencode")
i = l.first()
d.add_chfifo("z2h", "CPU3", "zigzag", "CPU4", "huffencode")
ch = d.get_chfifo("z2h")
ch.set_writer_interface("z2h_if")
ch.set_reader_interface("z2h_if")
ch.set_size("256")
rt = d.find_routes_chfifo("zigzag","huffencode",i)
d.set_chfifo_route("z2h",rt,i)

bus = d.getBus("OPB0")
bus.setTxLowAddr("TX0","0x00200000")
bus.setSyncType("q2z","INTERRUPT")
bus.setSyncType("z2h","INTERRUPT")

d.dump_everything()

name = cpath+"/jpeg_mpd_platform_demo.eds" # path should be absolute path
print d.saveToDisk(cpath+"/jpeg_mpd_platform_demo.eds")
