#!/usr/bin/python

import sys, os
pathname = os.path.dirname(sys.argv[0])
cpath = os.path.abspath(pathname)
sys.path.append(os.environ['ESE_PROJECT_ROOT']+"/lib/python2.3/site-packages") 

import esexml

d = esexml.design() # this is variable instantiation

d.loadFromDisk(cpath+"/mp3_hsd_platform_partial.eds")
d.set_design_name("mp3_hsd_platform_demo")

d.addPE("LFIL","HWIP","DCT32",0)

p = d.getPE("LFIL")
p.addPort("LFIL_PORT")
d.addConn("LFIL","LFIL_PORT","M","DH")

p.addProc("lfil_dct32")
proc = p.getProc("lfil_dct32")
clist = esexml.eseCharList()
hlist = esexml.eseCharList()
cname = cpath+"/mp3_srcs/lfil_dct32.c"
clist.append(cname)
hname = cpath+"/mp3_srcs/fixed.h"
hlist.append(hname)
proc.add_cfiles(clist)
proc.add_hfiles(hlist)
proc.addInterface("lfil2m",esexml.ESE_SEND)
intf = proc.getInterface("lfil2m")
intf.setTypeValue(esexml.ESE_SEND_STR,"send_P_ID_lfil_dct32_P_ID_mp3_main")
proc.addInterface("lfil2m",esexml.ESE_RECEIVE)
intf = proc.getInterface("lfil2m")
intf.setTypeValue(esexml.ESE_RECEIVE_STR,"recv_P_ID_lfil_dct32_P_ID_mp3_main")

d.addChp2p("CH_CPU_LFIL_F","CPU","mp3_main","LFIL","lfil_dct32","UNIDIRECTIONAL")
ch = d.getChp2p("CH_CPU_LFIL_F")
ch.setInterface1("m2lfil")
ch.setInterface2("lfil2m")
d.addChp2p("CH_CPU_LFIL_B","LFIL","lfil_dct32","CPU","mp3_main","UNIDIRECTIONAL")
ch = d.getChp2p("CH_CPU_LFIL_B")
ch.setInterface1("lfil2m")
ch.setInterface2("m2lfil")

rt = d.findRoutesp2p("mp3_main","lfil_dct32")
d.setChp2pRoute("CH_CPU_LFIL_F",rt)
rt = d.findRoutesp2p("lfil_dct32","mp3_main")
d.setChp2pRoute("CH_CPU_LFIL_B",rt)

bus = d.getBus("DH")
bus.setSyncType("CH_CPU_LFIL_F","INTERRUPT")
bus.setSyncType("CH_CPU_LFIL_B","INTERRUPT")
bus = d.getBus("OPB")
bus.setSyncType("CH_CPU_LFIL_F","INTERRUPT")
bus.setSyncType("CH_CPU_LFIL_B","INTERRUPT")

d.dump_everything()

name = cpath+"/mp3_hsd_platform_demo.eds" # path should be absolute path
print d.saveToDisk(cpath+"/mp3_hsd_platform_demo.eds")
