// MP3 fixed point SpecC version
extern int argc;
extern char **argv;

#ifdef SC
#include <stdio.h> //PC:
#include <sys/mman.h> //PC:
#include <unistd.h>
#include <sys/stat.h>
#include <stdlib.h> //PC:
#include <SDL/SDL.h>
#include <SDL/SDL_main.h>
#include <string.h>
#include <math.h>
extern void fill_audio(void *udata, Uint8 *stream, int len);
extern int end;
#ifdef VISUAL
 FILE *graph;
 FILE *graphPlot;
#endif
#else
#include "xparameters.h"
#include "xutil.h"
#endif
#include "global.h"
#include "mp3input.h"
#include "decoder.h"
#include "layer3.h"

#ifndef SC
#include "init.h"
#include "mp3_main_lpcm_imdct36.h"
#include "mp3_main_lfil_dct32.h"

#include "xgpio_l.h"

void WriteToGPOutputComplete(Xuint32 BaseAddress) {

   XGpio_mSetDataDirection(BaseAddress, 1, 0x00000000);   /* Set as outputs */
   XGpio_mSetDataReg(BaseAddress, 1, 1);
}
#endif

#define MP3BYTES 138972
//#define MP3BYTES 30

#ifdef HAVE_LIMITS_H
#  include <limits.h>
# else
#  define CHAR_BIT  8
# endif
# define SIZEOF_INT 4

extern mad_fixed_t const D[17][32];

# if defined(OPT_SSO)
#  if MAD_F_FRACBITS != 28
#   error "MAD_F_FRACBITS must be 28 to use OPT_SSO"
#  endif
#  define ML0(hi, lo, x, y)     ((lo)  = (x) * (y))
#  define MLA(hi, lo, x, y)     ((lo) += (x) * (y))
#  define MLN(hi, lo)           ((lo)  = -(lo))
#  define MLZ(hi, lo)           ((void) (hi), (mad_fixed_t) (lo))
#  define SHIFT(x)              ((x) >> 2)
#  define PRESHIFT(x)           ((MAD_F(x) + (1L << 13)) >> 14)
# else
#  define ML0(hi, lo, x, y)     MAD_F_ML0((hi), (lo), (x), (y))
#  define MLA(hi, lo, x, y)     MAD_F_MLA((hi), (lo), (x), (y))
#  define MLN(hi, lo)           MAD_F_MLN((hi), (lo))
#  define MLZ(hi, lo)           MAD_F_MLZ((hi), (lo))
#  define SHIFT(x)              (x)
#  if defined(MAD_F_SCALEBITS)
#   undef  MAD_F_SCALEBITS
#   define MAD_F_SCALEBITS      (MAD_F_FRACBITS - 12)
#   define PRESHIFT(x)          (MAD_F(x) >> 12)
#  else
#   define PRESHIFT(x)          MAD_F(x)
#  endif
# endif

# if defined(FPM_DEFAULT) && !defined(OPT_SSO)
#  define OPT_SSO
# endif

/* second SSO shift, with rounding */

# if defined(OPT_SSO)
#  define SHIFT(x)  (((x) + (1L << 11)) >> 12)
# else
#  define SHIFT(x)  (x)
# endif

/* possible DCT speed optimization */

# if defined(OPT_SPEED) && defined(MAD_F_MLX)
#  define OPT_DCTO
#  define MUL(x, y)  \
    ({ mad_fixed64hi_t hi;  \
       mad_fixed64lo_t lo;  \
       MAD_F_MLX(hi, lo, (x), (y));  \
       hi << (32 - MAD_F_SCALEBITS - 3);  \
    })
# else
#  undef OPT_DCTO
//#  define MUL(x, y)  mad_f_mul((x), (y))
#  define MUL(x, y)  ((((x) + (1L << 11)) >> 12) *  \
                                 (((y) + (1L << 15)) >> 16))
# endif


/************************Type Declaration begins***************/
struct buffer {
  unsigned char const *start;
  uln length;
};

/************************Type Declaration ends***************/


/************************Function Declaration begins***************/

enum mad_flow input(void *data,
                    struct mad_stream *stream);

enum mad_flow error(void *data,
                    struct mad_stream *stream,
                    struct mad_frame *frame);

enum mad_flow output(void *data,
                     struct mad_header const *header,
                     struct mad_pcm *pcm, unsigned char *outfile);

mad_fixed_t* calc_sample (
                  mad_fixed_t (*filter)[2][2][16][8],
                  unsigned int phase,
                  mad_fixed_t *pcm1);

//void init_sfbtable();

unsigned int III_scalefactors_lsf(struct mad_bitptr *ptr,
                                  struct channel_t *channelp,
                                  struct channel_t *gr1ch, int mode_extension);

unsigned int III_scalefactors(struct mad_bitptr *ptr, struct channel_t *channelp,
                              struct channel_t const *gr0ch, unsigned int scfsi);

enum mad_error III_huffdecode(struct mad_bitptr *ptr, mad_fixed_t xr[576],
                              struct channel_t *channelp,
                              unsigned char const *sfbwidth,
                              unsigned int part2_length);

enum mad_error III_stereo(mad_fixed_t xr[2][576],
                          struct granule const *granule,
                          struct mad_header *header,
                          unsigned char const *sfbwidth);

void III_reorder(mad_fixed_t xr[576], struct channel_t const *channelp,
                 unsigned char const sfbwidth[39]);

void III_aliasreduce(mad_fixed_t xr[576], int lines);

void III_imdct_l(mad_fixed_t const X[18], mad_fixed_t z[36],
                 unsigned int block_type);

void III_imdct_s(mad_fixed_t const X[18], mad_fixed_t z[36]);

void III_overlap(mad_fixed_t const output[36], mad_fixed_t overlap[18],
                 mad_fixed_t sample[18][32], unsigned int sb);

void III_freqinver(mad_fixed_t sample[18][32], unsigned int sb);

void III_overlap_z(mad_fixed_t overlap[18],
                   mad_fixed_t sample[18][32], unsigned int sb);

enum mad_error III_sideinfo(struct mad_bitptr *ptr, unsigned int nch,
                            int lsf, struct sideinfo *si,
                            unsigned int *data_bitlen,
                            unsigned int *priv_bitlen);

void mymemmove(void* dest, void* src, int size);

void mymemcpy (void* dest, void* src, int size);

/***********************Function Declaration end******************/

extern struct sfbtable_t const sfbwidth_table[9];


/*
 * This is perhaps the simplest example use of the MAD high-level API.
 * Standard input is mapped into memory via mmap(), then the high-level API
 * is invoked with three callbacks: input, output, and error. The output
 * callback converts MAD's high-resolution PCM samples to 16 bits, then
 * writes them to standard output in little-endian, stereo-interleaved
 * format.
 */

void imdct36 (mad_fixed_t const x[18], mad_fixed_t y[36])
{
    int tmp[18];
    int i;
	 

  //xil_printf("--------Starting imdct36 ----- \n");

    /* scale[i] = 2 * cos(PI * (2 * i + 1) / (4 * 18)) */
    int const scale[18] = {
      MAD_F(0x1ff833fa), MAD_F(0x1fb9ea93), MAD_F(0x1f3dd120),
      MAD_F(0x1e84d969), MAD_F(0x1d906bcf), MAD_F(0x1c62648b),
      MAD_F(0x1afd100f), MAD_F(0x1963268b), MAD_F(0x1797c6a4),
      MAD_F(0x159e6f5b), MAD_F(0x137af940), MAD_F(0x11318ef3),
      MAD_F(0x0ec6a507), MAD_F(0x0c3ef153), MAD_F(0x099f61c5),
      MAD_F(0x06ed12c5), MAD_F(0x042d4544), MAD_F(0x0165547c)
    };

    /* scale[i] = 2 * cos(PI * (2 * i + 1) / (2 * 18)) */
    int const sdct_scale[9] = {
      MAD_F(0x1fe0d3b4), MAD_F(0x1ee8dd47), MAD_F(0x1d007930),
      MAD_F(0x1a367e59), MAD_F(0x16a09e66), MAD_F(0x125abcf8),
      MAD_F(0x0d8616bc), MAD_F(0x08483ee1), MAD_F(0x02c9fad7)
    };

    int dctIV_tmp[18];
    int sdct_tmp[9];

    int fast_y[17];
    int a0,  a1,  a2,  a3,  a4,  a5,  a6,  a7,  a8,  a9,  a10, a11, a12;
    int a13, a14, a15, a16, a17, a18, a19, a20, a21, a22, a23, a24, a25;
    int m0,  m1,  m2,  m3,  m4,  m5,  m6,  m7;

    int const c0 =  MAD_F(0x1f838b8d);  /* 2 * cos( 1 * PI / 18) */
    int const c1 =  MAD_F(0x1bb67ae8);  /* 2 * cos( 3 * PI / 18) */
    int const c2 =  MAD_F(0x18836fa3);  /* 2 * cos( 4 * PI / 18) */
    int const c3 =  MAD_F(0x1491b752);  /* 2 * cos( 5 * PI / 18) */
    int const c4 =  MAD_F(0x0af1d43a);  /* 2 * cos( 7 * PI / 18) */
    int const c5 =  MAD_F(0x058e86a0);  /* 2 * cos( 8 * PI / 18) */
    int const c6 = -MAD_F(0x1e11f642);   /* 2 * cos(16 * PI / 18) */
    
    /* DCT-IV */

    /*  dctIV(x, tmp); manual in-line */
    {
      /* scaling */
      for (i = 0; i < 18; i += 3) {
	dctIV_tmp[i + 0] = mad_f_mul(x[i + 0], scale[i + 0]);
	dctIV_tmp[i + 1] = mad_f_mul(x[i + 1], scale[i + 1]);
	dctIV_tmp[i + 2] = mad_f_mul(x[i + 2], scale[i + 2]);
      }

      /* SDCT-II */

      /* sdctII(dctIV_tmp, tmp);  manual in-line */
      {
	/* divide the 18-point SDCT-II into two 9-point SDCT-IIs */

	/* even input butterfly */

	for (i = 0; i < 9; i += 3) {
	  sdct_tmp[i + 0] = dctIV_tmp[i + 0] + dctIV_tmp[18 - (i + 0) - 1];
	  sdct_tmp[i + 1] = dctIV_tmp[i + 1] + dctIV_tmp[18 - (i + 1) - 1];
	  sdct_tmp[i + 2] = dctIV_tmp[i + 2] + dctIV_tmp[18 - (i + 2) - 1];
	}

	/* fastsdct(sdct_tmp, &tmp[0]);  manual in-line */
	{ 
	  a0 = sdct_tmp[3] + sdct_tmp[5];
	  a1 = sdct_tmp[3] - sdct_tmp[5];
	  a2 = sdct_tmp[6] + sdct_tmp[2];
	  a3 = sdct_tmp[6] - sdct_tmp[2];
	  a4 = sdct_tmp[1] + sdct_tmp[7];
	  a5 = sdct_tmp[1] - sdct_tmp[7];
	  a6 = sdct_tmp[8] + sdct_tmp[0];
	  a7 = sdct_tmp[8] - sdct_tmp[0];

	  a8  = a0  + a2;
	  a9  = a0  - a2;
	  a10 = a0  - a6;
	  a11 = a2  - a6;
	  a12 = a8  + a6;
	  a13 = a1  - a3;
	  a14 = a13 + a7;
	  a15 = a3  + a7;
	  a16 = a1  - a7;
	  a17 = a1  + a3;

	  m0 = mad_f_mul(a17, -c3);
	  m1 = mad_f_mul(a16, -c0);
	  m2 = mad_f_mul(a15, -c4);
	  m3 = mad_f_mul(a14, -c1);
	  m4 = mad_f_mul(a5,  -c1);
	  m5 = mad_f_mul(a11, -c6);
	  m6 = mad_f_mul(a10, -c5);
	  m7 = mad_f_mul(a9,  -c2);

	  a18 =     sdct_tmp[4] + a4;
	  a19 = 2 * sdct_tmp[4] - a4;
	  a20 = a19 + m5;
	  a21 = a19 - m5;
	  a22 = a19 + m6;
	  a23 = m4  + m2;
	  a24 = m4  - m2;
	  a25 = m4  + m1;

	  /* output to every other slot for convenience */

	  tmp[ 0] = a18 + a12;
	  tmp[ 2] = m0  - a25;
	  tmp[ 4] = m7  - a20;
	  tmp[ 6] = m3;
	  tmp[ 8] = a21 - m6;
	  tmp[10] = a24 - m1;
	  tmp[12] = a12 - 2 * a18;
	  tmp[14] = a23 + m0;
	  tmp[16] = a22 + m7;
	} /* end fastsdct(sdct_tmp, &tmp[0]);  manual in-line */

	/* odd input butterfly and scaling */

	for (i = 0; i < 9; i += 3) {
	  sdct_tmp[i + 0] = mad_f_mul(dctIV_tmp[i + 0] - dctIV_tmp[18 - (i + 0) - 1], sdct_scale[i + 0]);
	  sdct_tmp[i + 1] = mad_f_mul(dctIV_tmp[i + 1] - dctIV_tmp[18 - (i + 1) - 1], sdct_scale[i + 1]);
	  sdct_tmp[i + 2] = mad_f_mul(dctIV_tmp[i + 2] - dctIV_tmp[18 - (i + 2) - 1], sdct_scale[i + 2]);
	}

	/* fastsdct(sdct_tmp, &tmp[1]);   manual in-line */
	{ 
	  for (i = 0; i < 17; i++)
	    fast_y[i] = tmp[i+1];

	  a0 = sdct_tmp[3] + sdct_tmp[5];
	  a1 = sdct_tmp[3] - sdct_tmp[5];
	  a2 = sdct_tmp[6] + sdct_tmp[2];
	  a3 = sdct_tmp[6] - sdct_tmp[2];
	  a4 = sdct_tmp[1] + sdct_tmp[7];
	  a5 = sdct_tmp[1] - sdct_tmp[7];
	  a6 = sdct_tmp[8] + sdct_tmp[0];
	  a7 = sdct_tmp[8] - sdct_tmp[0];

	  a8  = a0  + a2;
	  a9  = a0  - a2;
	  a10 = a0  - a6;
	  a11 = a2  - a6;
	  a12 = a8  + a6;
	  a13 = a1  - a3;
	  a14 = a13 + a7;
	  a15 = a3  + a7;
	  a16 = a1  - a7;
	  a17 = a1  + a3;

	  m0 = mad_f_mul(a17, -c3);
	  m1 = mad_f_mul(a16, -c0);
	  m2 = mad_f_mul(a15, -c4);
	  m3 = mad_f_mul(a14, -c1);
	  m4 = mad_f_mul(a5,  -c1);
	  m5 = mad_f_mul(a11, -c6);
	  m6 = mad_f_mul(a10, -c5);
	  m7 = mad_f_mul(a9,  -c2);

	  a18 =     sdct_tmp[4] + a4;
	  a19 = 2 * sdct_tmp[4] - a4;
	  a20 = a19 + m5;
	  a21 = a19 - m5;
	  a22 = a19 + m6;
	  a23 = m4  + m2;
	  a24 = m4  - m2;
	  a25 = m4  + m1;

	  /* output to every other slot for convenience */

	  fast_y[ 0] = a18 + a12;
	  fast_y[ 2] = m0  - a25;
	  fast_y[ 4] = m7  - a20;
	  fast_y[ 6] = m3;
	  fast_y[ 8] = a21 - m6;
	  fast_y[10] = a24 - m1;
	  fast_y[12] = a12 - 2 * a18;
	  fast_y[14] = a23 + m0;
	  fast_y[16] = a22 + m7;

	  for (i = 0; i < 17; i++)
	    tmp[i+1] = fast_y[i];
	} /* end fastsdct(sdct_tmp, &tmp[0]);  manual in-line */

	/* output accumulation */

	for (i = 3; i < 18; i += 8) {
	  tmp[i + 0] -= tmp[(i + 0) - 2];
	  tmp[i + 2] -= tmp[(i + 2) - 2];
	  tmp[i + 4] -= tmp[(i + 4) - 2];
	  tmp[i + 6] -= tmp[(i + 6) - 2];
	}
      } /* end sdctII(dctIV_tmp, tmp);  manual in-line */

      /* scale reduction and output accumulation */

// emulate a signed division 
#define RSHIFT1(x) (x < 0 ? (-(-x >> 1)) : (x>>1))
      tmp[0] = RSHIFT1(tmp[0]);
      for (i = 1; i < 17; i += 4) {
	tmp[i + 0] = RSHIFT1(tmp[i + 0]) - tmp[(i + 0) - 1];
	tmp[i + 1] = RSHIFT1(tmp[i + 1]) - tmp[(i + 1) - 1];
	tmp[i + 2] = RSHIFT1(tmp[i + 2]) - tmp[(i + 2) - 1];
	tmp[i + 3] = RSHIFT1(tmp[i + 3]) - tmp[(i + 3) - 1];
      }
      tmp[17] = RSHIFT1(tmp[17]) - tmp[16]; 
#undef RSHIFT1
    } /*  end dctIV(x, tmp); manual in-line */      

    /* convert 18-point DCT-IV to 36-point IMDCT */

    for (i =  0; i <  9; i += 3) {
      y[i + 0] =  tmp[9 + (i + 0)];
      y[i + 1] =  tmp[9 + (i + 1)];
      y[i + 2] =  tmp[9 + (i + 2)];
    }
    for (i =  9; i < 27; i += 3) {
      y[i + 0] = -tmp[36 - (9 + (i + 0)) - 1];
      y[i + 1] = -tmp[36 - (9 + (i + 1)) - 1];
      y[i + 2] = -tmp[36 - (9 + (i + 2)) - 1];
    }
    for (i = 27; i < 36; i += 3) {
      y[i + 0] = -tmp[(i + 0) - 27];
      y[i + 1] = -tmp[(i + 1) - 27];
      y[i + 2] = -tmp[(i + 2) - 27];
    }
  }

/*
 * NAME:	dct32()
 * DESCRIPTION:	perform fast in[32]->out[32] DCT
 */
void dct32(mad_fixed_t const inp[32], mad_fixed_t lo[16], mad_fixed_t hi[16])
{
  mad_fixed_t t0,   t1,   t2,   t3,   t4,   t5,   t6,   t7;
  mad_fixed_t t8,   t9,   t10,  t11,  t12,  t13,  t14,  t15;
  mad_fixed_t t16,  t17,  t18,  t19,  t20,  t21,  t22,  t23;
  mad_fixed_t t24,  t25,  t26,  t27,  t28,  t29,  t30,  t31;
  mad_fixed_t t32,  t33,  t34,  t35,  t36,  t37,  t38,  t39;
  mad_fixed_t t40,  t41,  t42,  t43,  t44,  t45,  t46,  t47;
  mad_fixed_t t48,  t49,  t50,  t51,  t52,  t53,  t54,  t55;
  mad_fixed_t t56,  t57,  t58,  t59,  t60,  t61,  t62,  t63;
  mad_fixed_t t64,  t65,  t66,  t67,  t68,  t69,  t70,  t71;
  mad_fixed_t t72,  t73,  t74,  t75,  t76,  t77,  t78,  t79;
  mad_fixed_t t80,  t81,  t82,  t83,  t84,  t85,  t86,  t87;
  mad_fixed_t t88,  t89,  t90,  t91,  t92,  t93,  t94,  t95;
  mad_fixed_t t96,  t97,  t98,  t99,  t100, t101, t102, t103;
  mad_fixed_t t104, t105, t106, t107, t108, t109, t110, t111;
  mad_fixed_t t112, t113, t114, t115, t116, t117, t118, t119;
  mad_fixed_t t120, t121, t122, t123, t124, t125, t126, t127;
  mad_fixed_t t128, t129, t130, t131, t132, t133, t134, t135;
  mad_fixed_t t136, t137, t138, t139, t140, t141, t142, t143;
  mad_fixed_t t144, t145, t146, t147, t148, t149, t150, t151;
  mad_fixed_t t152, t153, t154, t155, t156, t157, t158, t159;
  mad_fixed_t t160, t161, t162, t163, t164, t165, t166, t167;
  mad_fixed_t t168, t169, t170, t171, t172, t173, t174, t175;
  mad_fixed_t t176;

  /* costab[i] = cos(PI / (2 * 32) * i) */

# if defined(OPT_DCTO)
#  define costab1	MAD_F(0x7fd8878e)
#  define costab2	MAD_F(0x7f62368f)
#  define costab3	MAD_F(0x7e9d55fc)
#  define costab4	MAD_F(0x7d8a5f40)
#  define costab5	MAD_F(0x7c29fbee)
#  define costab6	MAD_F(0x7a7d055b)
#  define costab7	MAD_F(0x78848414)
#  define costab8	MAD_F(0x7641af3d)
#  define costab9	MAD_F(0x73b5ebd1)
#  define costab10	MAD_F(0x70e2cbc6)
#  define costab11	MAD_F(0x6dca0d14)
#  define costab12	MAD_F(0x6a6d98a4)
#  define costab13	MAD_F(0x66cf8120)
#  define costab14	MAD_F(0x62f201ac)
#  define costab15	MAD_F(0x5ed77c8a)
#  define costab16	MAD_F(0x5a82799a)
#  define costab17	MAD_F(0x55f5a4d2)
#  define costab18	MAD_F(0x5133cc94)
#  define costab19	MAD_F(0x4c3fdff4)
#  define costab20	MAD_F(0x471cece7)
#  define costab21	MAD_F(0x41ce1e65)
#  define costab22	MAD_F(0x3c56ba70)
#  define costab23	MAD_F(0x36ba2014)
#  define costab24	MAD_F(0x30fbc54d)
#  define costab25	MAD_F(0x2b1f34eb)
#  define costab26	MAD_F(0x25280c5e)
#  define costab27	MAD_F(0x1f19f97b)
#  define costab28	MAD_F(0x18f8b83c)
#  define costab29	MAD_F(0x12c8106f)
#  define costab30	MAD_F(0x0c8bd35e)
#  define costab31	MAD_F(0x0647d97c)
# else
#  define costab1	MAD_F(0x0ffb10f2)  /* 0.998795456 */
#  define costab2	MAD_F(0x0fec46d2)  /* 0.995184727 */
#  define costab3	MAD_F(0x0fd3aac0)  /* 0.989176510 */
#  define costab4	MAD_F(0x0fb14be8)  /* 0.980785280 */
#  define costab5	MAD_F(0x0f853f7e)  /* 0.970031253 */
#  define costab6	MAD_F(0x0f4fa0ab)  /* 0.956940336 */
#  define costab7	MAD_F(0x0f109082)  /* 0.941544065 */
#  define costab8	MAD_F(0x0ec835e8)  /* 0.923879533 */
#  define costab9	MAD_F(0x0e76bd7a)  /* 0.903989293 */
#  define costab10	MAD_F(0x0e1c5979)  /* 0.881921264 */
#  define costab11	MAD_F(0x0db941a3)  /* 0.857728610 */
#  define costab12	MAD_F(0x0d4db315)  /* 0.831469612 */
#  define costab13	MAD_F(0x0cd9f024)  /* 0.803207531 */
#  define costab14	MAD_F(0x0c5e4036)  /* 0.773010453 */
#  define costab15	MAD_F(0x0bdaef91)  /* 0.740951125 */
#  define costab16	MAD_F(0x0b504f33)  /* 0.707106781 */
#  define costab17	MAD_F(0x0abeb49a)  /* 0.671558955 */
#  define costab18	MAD_F(0x0a267993)  /* 0.634393284 */
#  define costab19	MAD_F(0x0987fbfe)  /* 0.595699304 */
#  define costab20	MAD_F(0x08e39d9d)  /* 0.555570233 */
#  define costab21	MAD_F(0x0839c3cd)  /* 0.514102744 */
#  define costab22	MAD_F(0x078ad74e)  /* 0.471396737 */
#  define costab23	MAD_F(0x06d74402)  /* 0.427555093 */
#  define costab24	MAD_F(0x061f78aa)  /* 0.382683432 */
#  define costab25	MAD_F(0x0563e69d)  /* 0.336889853 */
#  define costab26	MAD_F(0x04a5018c)  /* 0.290284677 */
#  define costab27	MAD_F(0x03e33f2f)  /* 0.242980180 */
#  define costab28	MAD_F(0x031f1708)  /* 0.195090322 */
#  define costab29	MAD_F(0x0259020e)  /* 0.146730474 */
#  define costab30	MAD_F(0x01917a6c)  /* 0.098017140 */
#  define costab31	MAD_F(0x00c8fb30)  /* 0.049067674 */
# endif

 // xil_printf("--------Starting dct32 ----- \n");
  
  t0   = inp[0]  + inp[31];  t16  = MUL(inp[0]  - inp[31], costab1);
  t1   = inp[15] + inp[16];  t17  = MUL(inp[15] - inp[16], costab31);

  t41  = t16 + t17;
  t59  = MUL(t16 - t17, costab2);
  t33  = t0  + t1;
  t50  = MUL(t0  - t1,  costab2);

  t2   = inp[7]  + inp[24];  t18  = MUL(inp[7]  - inp[24], costab15);
  t3   = inp[8]  + inp[23];  t19  = MUL(inp[8]  - inp[23], costab17);

  t42  = t18 + t19;
  t60  = MUL(t18 - t19, costab30);
  t34  = t2  + t3;
  t51  = MUL(t2  - t3,  costab30);

  t4   = inp[3]  + inp[28];  t20  = MUL(inp[3]  - inp[28], costab7);
  t5   = inp[12] + inp[19];  t21  = MUL(inp[12] - inp[19], costab25);

  t43  = t20 + t21;
  t61  = MUL(t20 - t21, costab14);
  t35  = t4  + t5;
  t52  = MUL(t4  - t5,  costab14);

  t6   = inp[4]  + inp[27];  t22  = MUL(inp[4]  - inp[27], costab9);
  t7   = inp[11] + inp[20];  t23  = MUL(inp[11] - inp[20], costab23);

  t44  = t22 + t23;
  t62  = MUL(t22 - t23, costab18);
  t36  = t6  + t7;
  t53  = MUL(t6  - t7,  costab18);

  t8   = inp[1]  + inp[30];  t24  = MUL(inp[1]  - inp[30], costab3);
  t9   = inp[14] + inp[17];  t25  = MUL(inp[14] - inp[17], costab29);

  t45  = t24 + t25;
  t63  = MUL(t24 - t25, costab6);
  t37  = t8  + t9;
  t54  = MUL(t8  - t9,  costab6);

  t10  = inp[6]  + inp[25];  t26  = MUL(inp[6]  - inp[25], costab13);
  t11  = inp[9]  + inp[22];  t27  = MUL(inp[9]  - inp[22], costab19);

  t46  = t26 + t27;
  t64  = MUL(t26 - t27, costab26);
  t38  = t10 + t11;
  t55  = MUL(t10 - t11, costab26);

  t12  = inp[2]  + inp[29];  t28  = MUL(inp[2]  - inp[29], costab5);
  t13  = inp[13] + inp[18];  t29  = MUL(inp[13] - inp[18], costab27);

  t47  = t28 + t29;
  t65  = MUL(t28 - t29, costab10);
  t39  = t12 + t13;
  t56  = MUL(t12 - t13, costab10);

  t14  = inp[5]  + inp[26];  t30  = MUL(inp[5]  - inp[26], costab11);
  t15  = inp[10] + inp[21];  t31  = MUL(inp[10] - inp[21], costab21);

  t48  = t30 + t31;
  t66  = MUL(t30 - t31, costab22);
  t40  = t14 + t15;
  t57  = MUL(t14 - t15, costab22);

  t69  = t33 + t34;  t89  = MUL(t33 - t34, costab4);
  t70  = t35 + t36;  t90  = MUL(t35 - t36, costab28);
  t71  = t37 + t38;  t91  = MUL(t37 - t38, costab12);
  t72  = t39 + t40;  t92  = MUL(t39 - t40, costab20);
  t73  = t41 + t42;  t94  = MUL(t41 - t42, costab4);
  t74  = t43 + t44;  t95  = MUL(t43 - t44, costab28);
  t75  = t45 + t46;  t96  = MUL(t45 - t46, costab12);
  t76  = t47 + t48;  t97  = MUL(t47 - t48, costab20);

  t78  = t50 + t51;  t100 = MUL(t50 - t51, costab4);
  t79  = t52 + t53;  t101 = MUL(t52 - t53, costab28);
  t80  = t54 + t55;  t102 = MUL(t54 - t55, costab12);
  t81  = t56 + t57;  t103 = MUL(t56 - t57, costab20);

  t83  = t59 + t60;  t106 = MUL(t59 - t60, costab4);
  t84  = t61 + t62;  t107 = MUL(t61 - t62, costab28);
  t85  = t63 + t64;  t108 = MUL(t63 - t64, costab12);
  t86  = t65 + t66;  t109 = MUL(t65 - t66, costab20);

  t113 = t69  + t70;
  t114 = t71  + t72;

  /*  0 */ hi[15] = SHIFT(t113 + t114);
  /* 16 */ lo[ 0] = SHIFT(MUL(t113 - t114, costab16));

  t115 = t73  + t74;
  t116 = t75  + t76;

  t32  = t115 + t116;

  /*  1 */ hi[14] = SHIFT(t32);

  t118 = t78  + t79;
  t119 = t80  + t81;

  t58  = t118 + t119;

  /*  2 */ hi[13] = SHIFT(t58);

  t121 = t83  + t84;
  t122 = t85  + t86;

  t67  = t121 + t122;

  t49  = (t67 * 2) - t32;

  /*  3 */ hi[12] = SHIFT(t49);

  t125 = t89  + t90;
  t126 = t91  + t92;

  t93  = t125 + t126;

  /*  4 */ hi[11] = SHIFT(t93);

  t128 = t94  + t95;
  t129 = t96  + t97;

  t98  = t128 + t129;

  t68  = (t98 * 2) - t49;

  /*  5 */ hi[10] = SHIFT(t68);

  t132 = t100 + t101;
  t133 = t102 + t103;

  t104 = t132 + t133;

  t82  = (t104 * 2) - t58;

  /*  6 */ hi[ 9] = SHIFT(t82);

  t136 = t106 + t107;
  t137 = t108 + t109;

  t110 = t136 + t137;

  t87  = (t110 * 2) - t67;

  t77  = (t87 * 2) - t68;

  /*  7 */ hi[ 8] = SHIFT(t77);

  t141 = MUL(t69 - t70, costab8);
  t142 = MUL(t71 - t72, costab24);
  t143 = t141 + t142;

  /*  8 */ hi[ 7] = SHIFT(t143);
  /* 24 */ lo[ 8] =
	     SHIFT((MUL(t141 - t142, costab16) * 2) - t143);

  t144 = MUL(t73 - t74, costab8);
  t145 = MUL(t75 - t76, costab24);
  t146 = t144 + t145;

  t88  = (t146 * 2) - t77;

  /*  9 */ hi[ 6] = SHIFT(t88);

  t148 = MUL(t78 - t79, costab8);
  t149 = MUL(t80 - t81, costab24);
  t150 = t148 + t149;

  t105 = (t150 * 2) - t82;

  /* 10 */ hi[ 5] = SHIFT(t105);

  t152 = MUL(t83 - t84, costab8);
  t153 = MUL(t85 - t86, costab24);
  t154 = t152 + t153;

  t111 = (t154 * 2) - t87;

  t99  = (t111 * 2) - t88;

  /* 11 */ hi[ 4] = SHIFT(t99);

  t157 = MUL(t89 - t90, costab8);
  t158 = MUL(t91 - t92, costab24);
  t159 = t157 + t158;

  t127 = (t159 * 2) - t93;

  /* 12 */ hi[ 3] = SHIFT(t127);

  t160 = (MUL(t125 - t126, costab16) * 2) - t127;

  /* 20 */ lo[ 4] = SHIFT(t160);
  /* 28 */ lo[12] =
	     SHIFT((((MUL(t157 - t158, costab16) * 2) - t159) * 2) - t160);

  t161 = MUL(t94 - t95, costab8);
  t162 = MUL(t96 - t97, costab24);
  t163 = t161 + t162;

  t130 = (t163 * 2) - t98;

  t112 = (t130 * 2) - t99;

  /* 13 */ hi[ 2] = SHIFT(t112);

  t164 = (MUL(t128 - t129, costab16) * 2) - t130;

  t166 = MUL(t100 - t101, costab8);
  t167 = MUL(t102 - t103, costab24);
  t168 = t166 + t167;

  t134 = (t168 * 2) - t104;

  t120 = (t134 * 2) - t105;

  /* 14 */ hi[ 1] = SHIFT(t120);

  t135 = (MUL(t118 - t119, costab16) * 2) - t120;

  /* 18 */ lo[ 2] = SHIFT(t135);

  t169 = (MUL(t132 - t133, costab16) * 2) - t134;

  t151 = (t169 * 2) - t135;

  /* 22 */ lo[ 6] = SHIFT(t151);

  t170 = (((MUL(t148 - t149, costab16) * 2) - t150) * 2) - t151;

  /* 26 */ lo[10] = SHIFT(t170);
  /* 30 */ lo[14] =
	     SHIFT((((((MUL(t166 - t167, costab16) * 2) -
		       t168) * 2) - t169) * 2) - t170);

  t171 = MUL(t106 - t107, costab8);
  t172 = MUL(t108 - t109, costab24);
  t173 = t171 + t172;

  t138 = (t173 * 2) - t110;

  t123 = (t138 * 2) - t111;

  t139 = (MUL(t121 - t122, costab16) * 2) - t123;

  t117 = (t123 * 2) - t112;

  /* 15 */ hi[ 0] = SHIFT(t117);

  t124 = (MUL(t115 - t116, costab16) * 2) - t117;

  /* 17 */ lo[ 1] = SHIFT(t124);

  t131 = (t139 * 2) - t124;

  /* 19 */ lo[ 3] = SHIFT(t131);

  t140 = (t164 * 2) - t131;

  /* 21 */ lo[ 5] = SHIFT(t140);

  t174 = (MUL(t136 - t137, costab16) * 2) - t138;

  t155 = (t174 * 2) - t139;

  t147 = (t155 * 2) - t140;

  /* 23 */ lo[ 7] = SHIFT(t147);

  t156 = (((MUL(t144 - t145, costab16) * 2) - t146) * 2) - t147;

  /* 25 */ lo[ 9] = SHIFT(t156);

  t175 = (((MUL(t152 - t153, costab16) * 2) - t154) * 2) - t155;

  t165 = (t175 * 2) - t156;

  /* 27 */ lo[11] = SHIFT(t165);

  t176 = (((((MUL(t161 - t162, costab16) * 2) -
	     t163) * 2) - t164) * 2) - t165;

  /* 29 */ lo[13] = SHIFT(t176);
  /* 31 */ lo[15] =
	     SHIFT((((((((MUL(t171 - t172, costab16) * 2) -
			 t173) * 2) - t174) * 2) - t175) * 2) - t176);

  /*
   * Totals:
   *  80 multiplies
   *  80 additions
   * 119 subtractions
   *  49 shifts (not counting SSO)
   */
}

/*******************Application code begin************/

/*
 * NAME:	III_decode()
 * DESCRIPTION:	decode frame main_data
 */
enum mad_error III_decode(struct mad_bitptr *ptr, struct mad_frame *frame,
			  struct sideinfo *si, unsigned int nch)
{
  struct mad_header *header;
  unsigned int sfreqi, ngr, gr;
  header = &frame->header;

  {
    unsigned int sfreq;

    //init_sfbtable();
    sfreq = header->samplerate;
    if (header->flags & MAD_FLAG_MPEG_2_5_EXT)
      sfreq *= 2;

    /* 48000 => 0, 44100 => 1, 32000 => 2,
       24000 => 3, 22050 => 4, 16000 => 5 */
    sfreqi = ((sfreq >>  7) & 0x000f) +
             ((sfreq >> 15) & 0x0001) - 8;

    if (header->flags & MAD_FLAG_MPEG_2_5_EXT)
      sfreqi += 3;
  }

	    //xil_printf("--------Entered III decode ----- \n");

  /* scalefactors, Huffman decoding, requantization */

  ngr = (header->flags & MAD_FLAG_LSF_EXT) ? 1 : 2;

  for (gr = 0; gr < ngr; ++gr) {
    struct granule *granule;
    unsigned char const *sfbwidth[2];
    mad_fixed_t xr[2][576];
    unsigned int ch;
    enum mad_error error;

    granule = &si->gr[gr];
    for (ch = 0; ch < nch; ++ch) {
      struct channel_t *channelp;
      unsigned int part2_length;

	    //xil_printf("--------Going over granules----- \n");

      channelp = &granule->ch[ch];
      sfbwidth[ch] = sfbwidth_table[sfreqi].l;
      if (channelp->block_type == 2) {
	sfbwidth[ch] = (channelp->flags & mixed_block_flag) ?
	  sfbwidth_table[sfreqi].m : sfbwidth_table[sfreqi].s;
      }

      if (header->flags & MAD_FLAG_LSF_EXT) {
	if (ch == 0) 
	  part2_length = III_scalefactors_lsf(ptr, channelp,
					    0,
					    header->mode_extension);
	else 
	  part2_length = III_scalefactors_lsf(ptr, channelp,
                                            &si->gr[1].ch[1],
                                            header->mode_extension);
      }
      else {
	part2_length = III_scalefactors(ptr, channelp, &si->gr[0].ch[ch],
					gr == 0 ? 0 : si->scfsi[ch]);
      }

      error = III_huffdecode(ptr, xr[ch], channelp, sfbwidth[ch], part2_length);
	    //xil_printf("--------After huff decode ----- \n");

      if (error)
	return error;
        //xil_printf("--------huff decode is aight ----- \n");

    }

    /* joint stereo processing */

    if (header->mode == MAD_MODE_JOINT_STEREO && header->mode_extension) {
      error = III_stereo(xr, granule, header, sfbwidth[0]);
      if (error)
	return error;
    }

    /* reordering, alias reduction, IMDCT, overlap-add, frequency inversion */

    for (ch = 0; ch < nch; ++ch) {
      struct channel_t const *channelp;
      channelp = &granule->ch[ch];
      if (channelp->block_type == 2) {
	III_reorder(xr[ch], channelp, sfbwidth[ch]);

# if !defined(OPT_STRICT)
	/*
	 * According to ISO/IEC 11172-3, "Alias reduction is not applied for
	 * granules with block_type == 2 (short block)." However, other
	 * sources suggest alias reduction should indeed be performed on the
	 * lower two subbands of mixed blocks. Most other implementations do
	 * this, so by default we will too.
	 */
	if (channelp->flags & mixed_block_flag)
	  III_aliasreduce(xr[ch], 36);
# endif
      }
      else
	III_aliasreduce(xr[ch], 576);
    }
    {
      struct channel_t const *channelp;
      mad_fixed_t (*sample)[32];
      unsigned int sb, l, i, sblimit;
      mad_fixed_t output[36];
      unsigned int block_type;

      struct channel_t const *channel2;
      mad_fixed_t (*sample2)[32];
      unsigned int sblimit2;
      mad_fixed_t output2[36];
      unsigned int block_type2;

      channelp = &granule->ch[0];
      sample = &frame->sbsample[0][18 * gr];
      l = 0;
      if (nch == 2) {
	channel2 = &granule->ch[1];
	sample2 = &frame->sbsample[1][18 * gr];
      }

      /* subbands 0-1 */
      block_type = channelp->block_type;
      if (channelp->flags & mixed_block_flag)
	block_type = 0;

      if (nch == 2) {
	block_type2 = channel2->block_type;
	if (channel2->flags & mixed_block_flag)
	  block_type2 = 0;
      }

      for (sb = 0; sb < 2; ++sb, l += 18) {
	if (channelp->block_type != 2 || (channelp->flags & mixed_block_flag)) {
	  /* long blocks */
	  /********sending data for other MB (LPCM) to work in parallel **************/
	  send_P_ID_mp3_main_P_ID_lpcm_imdct36(&xr[0][l],sizeof(mad_fixed_t[18]));
          
	  if ((nch == 2) &&
              (channel2->block_type != 2 || (channel2->flags & mixed_block_flag)))  {
            imdct36 (&xr[1][l], output2);
          }
           
          recv_P_ID_mp3_main_P_ID_lpcm_imdct36(output,sizeof(mad_fixed_t[36]));
	  /******** parallel execution of IMDCTs has completed **************/

	  III_imdct_l(&xr[0][l], output, block_type); /*** receive */

	  if ((nch == 2) &&
	      (channel2->block_type != 2 || (channel2->flags & mixed_block_flag))) {
	    /* long blocks */
	    III_imdct_l(&xr[1][l], output2, block_type2); /*** receive */
	  }
	  else {
	    /* short blocks */
	    III_imdct_s(&xr[1][l], output2);
	  }
	}
	else {
	  /* short blocks */
	  III_imdct_s(&xr[0][l], output);
	  if ((nch == 2) &&
	      (channel2->block_type != 2 || (channel2->flags & mixed_block_flag))) {
	    /* long blocks */
		imdct36 (&xr[1][l], output2);
	   	III_imdct_l(&xr[1][l], output2, block_type2); /*** receive */
	  } else {
	    /* short blocks */
	    III_imdct_s(&xr[1][l], output2);
	  }	
	}
	III_overlap(output, (*frame->overlap)[0][sb], sample, sb);
	if (sb & 1)
	    III_freqinver(sample, sb);

	if (nch == 2) {
	  III_overlap(output2, (*frame->overlap)[1][sb], sample2, sb);
	  if (sb & 1)
	    III_freqinver(sample2, sb);
	}
      }

      /* (nonzero) subbands 2-31 */
      i = 576;
      while (i > 36 && xr[0][i - 1] == 0)
	--i;
      sblimit = 32 - (576 - i) / 18;

      if (nch == 2) {
	i = 576;
	while (i > 36 && xr[1][i - 1] == 0)
	  --i;
	sblimit2 = 32 - (576 - i) / 18;
      }
      
      for (sb = 2; sb < sblimit && sb < sblimit2; ++sb, l += 18) {
	if (channelp->block_type != 2) {
	  /* long blocks */
          /********sending data for IMDCTs to work in parallel **************/
	  if (sb < sblimit)  {
        send_P_ID_mp3_main_P_ID_lpcm_imdct36(&xr[0][l],sizeof(mad_fixed_t[18]));
        
	if (sb < sblimit2 && nch == 2 && channel2->block_type != 2) {
                imdct36 (&xr[1][l], output2);
          }

	recv_P_ID_mp3_main_P_ID_lpcm_imdct36(output,sizeof(mad_fixed_t[36]));
	  }
          /******** parallel execution of IMDCTs has completed **************/

	  if (sb < sblimit) 
	    III_imdct_l(&xr[0][l], output, channelp->block_type); /*** receive */

	  if (sb < sblimit2 && nch == 2 && channel2->block_type != 2) {
	      /* long blocks */
	      III_imdct_l(&xr[1][l], output2, channel2->block_type); /*** receive */
	  }
	  else {
	    /* short blocks */
	    III_imdct_s(&xr[1][l], output2);
	  }
	}
	else {
	  /* short blocks */
	  if (sb < sblimit) 
	    III_imdct_s(&xr[0][l], output);
	  if (sb < sblimit2 && nch == 2) {
	    if (channel2->block_type != 2) {
	      /* long blocks */
		  imdct36 (&xr[1][l], output2);
	      	  III_imdct_l(&xr[1][l], output2, channel2->block_type);
	    }
	    else {
	      /* short blocks */
	      III_imdct_s(&xr[1][l], output2);
	    }
	  }
	}
	if (sb < sblimit) {
	  III_overlap(output, (*frame->overlap)[0][sb], sample, sb);
	    
	  if (sb & 1)
	    III_freqinver(sample, sb);
	}
	if (sb < sblimit2 && nch == 2) {
	  III_overlap(output2, (*frame->overlap)[1][sb], sample2, sb);

	  if (sb & 1)
	    III_freqinver(sample2, sb);
	}
      }

      /* remaining (zero) subbands */
      for (sb = sblimit; sb < 32; ++sb) {
	III_overlap_z((*frame->overlap)[0][sb], sample, sb);

	if (sb & 1)
	  III_freqinver(sample, sb);
      }
      if (nch == 2) {
	for (sb = sblimit2; sb < 32; ++sb) {
	  III_overlap_z((*frame->overlap)[1][sb], sample2, sb);
	  
	  if (sb & 1)
	    III_freqinver(sample2, sb);
	}
      }
    }
  }

  return MAD_ERROR_NONE;
}

/*
 * NAME:	layer->III()
 * DESCRIPTION:	decode a single Layer III frame
 */
int mad_layer_III(struct mad_stream *stream, struct mad_frame *frame)
{
  struct mad_header *header;
  unsigned int nch, priv_bitlen, next_md_begin = 0;
  unsigned int si_len, data_bitlen, md_len;
  unsigned int frame_space, frame_used, frame_free;
  struct mad_bitptr ptr;
  struct sideinfo si;
  enum mad_error error;
  int result = 0;
  header = &frame->header;

  /* allocate Layer III dynamic structures */

  if (stream->main_data == 0) {
    stream->main_data = &stream->for_main_data/*[0]*/;
    if (stream->main_data == 0) {
      stream->error = MAD_ERROR_NOMEM;
//	  	xil_printf("--------Error layer III - No mem ----- \n");
      return -1;
    }
  }

  if (frame->overlap == 0) {
    frame->overlap = &frame->for_overlap;

    if (frame->overlap == 0) {
      stream->error = MAD_ERROR_NOMEM;
//	  	xil_printf("--------Error layer III - No mem ----- \n");
 
      return -1;
    }
  }

  nch = MAD_NCHANNELS(header);
  si_len = (header->flags & MAD_FLAG_LSF_EXT) ?
    (nch == 1 ? 9 : 17) : (nch == 1 ? 17 : 32);

  /* check frame sanity */

  if ((signed int)(stream->next_frame) - (signed int)(mad_bit_nextbyte(&stream->ptr)) <
      (signed int) si_len) {
    stream->error = MAD_ERROR_BADFRAMELEN;
    stream->md_len = 0;
// 	  	xil_printf("--------Error layer III - bad frame len ----- \n");
    return -1;
  }

  /* check CRC word */

  if (header->flags & MAD_FLAG_PROTECTION) {
    header->crc_check =
      mad_bit_crc(& stream->ptr, si_len * CHAR_BIT, header->crc_check);

    if (header->crc_check != header->crc_target &&
	!(frame->options & MAD_OPTION_IGNORECRC)) {
      stream->error = MAD_ERROR_BADCRC;
//	  	xil_printf("--------Error layer III - bad crc ----- \n");
       result = -1;
    }
  }

  /* decode frame side information */

  error = III_sideinfo(&stream->ptr, nch, header->flags & MAD_FLAG_LSF_EXT,
		       &si, &data_bitlen, &priv_bitlen);
//xil_printf("--------After III sideinfo ----- \n");

  if (error && result == 0) {
    //xil_printf("--------Error in III sideinfo ----- \n");

    stream->error = error;
    result = -1;
  }

  header->flags        |= priv_bitlen;
  header->private_bits |= si.private_bits;

  /* find main_data of next frame */

  {
    struct mad_bitptr peek;
    uln header;

    mad_bit_init(&peek, stream->next_frame);

    header = mad_bit_read(&peek, 32);
    if ((header & 0xffe60000L) /* syncword | layer */ == 0xffe20000L) {
      if (!(header & 0x00010000L))  /* protection_bit */
	mad_bit_skip(&peek, 16);  /* crc_check */

      next_md_begin =
	mad_bit_read(&peek, (header & 0x00080000L) /* ID */ ? 9 : 8);
    }

    mad_bit_finish(&peek);
  }

  /* find main_data of this frame */

  frame_space = (unsigned int)stream->next_frame - (unsigned int)mad_bit_nextbyte(&stream->ptr);

  if (next_md_begin > si.main_data_begin + frame_space)
    next_md_begin = 0;

  md_len = si.main_data_begin + frame_space - next_md_begin;

  frame_used = 0;

  if (si.main_data_begin == 0) {
    //ptr = stream->ptr;
	mymemcpy(&ptr, &stream->ptr, sizeof(struct mad_bitptr));

    stream->md_len = 0;

    frame_used = md_len;
  }
  else {
    if (si.main_data_begin > stream->md_len) {
      if (result == 0) {
	stream->error = MAD_ERROR_BADDATAPTR;
	result = -1;
      }
    }
    else {
      mad_bit_init(&ptr,
		   *stream->main_data + stream->md_len - si.main_data_begin);

      if (md_len > si.main_data_begin) {
	assert(stream->md_len + md_len -
	       si.main_data_begin <= MAD_BUFFER_MDLEN);
	mymemcpy(*stream->main_data + stream->md_len,
	       (void *)mad_bit_nextbyte(&stream->ptr),
	       (int)(frame_used = md_len - si.main_data_begin));

	stream->md_len += frame_used;
      }
    }
  }

  frame_free = frame_space - frame_used;

  /* decode main_data */

  if (result == 0) {
    error = III_decode(&ptr, frame, &si, nch);
    if (error) {
      stream->error = error;
      result = -1;
    }

    /* designate ancillary bits */

    //stream->anc_ptr    = ptr;
	mymemcpy(&stream->anc_ptr, &ptr, sizeof(struct mad_bitptr));

    stream->anc_bitlen = md_len * CHAR_BIT - data_bitlen;
  }

  /* preload main_data buffer with up to 511 bytes for next frame(s) */

  if (frame_free >= next_md_begin) {
    mymemcpy(*stream->main_data,
	   (void *)(stream->next_frame - next_md_begin), next_md_begin);
    stream->md_len = next_md_begin;
  }
  else {
    if (md_len < si.main_data_begin) {
      unsigned int extra;

      extra = si.main_data_begin - md_len;
      if (extra + frame_free > next_md_begin)
	extra = next_md_begin - frame_free;

      if (extra < stream->md_len) {
	mymemmove(*stream->main_data,
		*stream->main_data + stream->md_len - extra, extra);
	stream->md_len = extra;
      }
    }
    else
      stream->md_len = 0;
    mymemcpy(*stream->main_data + stream->md_len,
	   (void *)(stream->next_frame - frame_free), frame_free);
    stream->md_len += frame_free;
  }

  return result;
}

# undef MUL


/*
 * NAME:	synth->full()
 * DESCRIPTION:	perform full frequency PCM synthesis
 */
void synth_full(struct mad_synth *synth, struct mad_frame const *frame,
		unsigned int nch, unsigned int ns)
{
  unsigned int phase, ch, s;
  mad_fixed_t *pcm1, (*filter)[2][2][16][8];
  mad_fixed_t const (*sbsample)[36][32];

  unsigned int phase2;
  mad_fixed_t *pcm2, (*filter2)[2][2][16][8];
  mad_fixed_t const (*sbsample2)[36][32];
  mad_fixed_t flo[16], fhi[16], flo2[16], fhi2[16];
  int i;


  sbsample = &frame->sbsample[0];
  filter   = &synth->filter[0];
  phase    = synth->phase;
  pcm1     = synth->pcm.samples[0];
  if (nch == 2) {
    sbsample2 = &frame->sbsample[1];
    filter2   = &synth->filter[1];
    phase2    = synth->phase;
    pcm2     = synth->pcm.samples[1];
  }

  for (s = 0; s < ns; ++s) {
	/*******sending data to LFIL***********/
	send_P_ID_mp3_main_P_ID_lfil_dct32((*sbsample)[s],sizeof(mad_fixed_t[32]));

	dct32 ((*sbsample2)[s], flo2, fhi2);

        recv_P_ID_mp3_main_P_ID_lfil_dct32(flo,sizeof(mad_fixed_t[16]));
        recv_P_ID_mp3_main_P_ID_lfil_dct32(fhi,sizeof(mad_fixed_t[16]));
    	/*******done receiving data from LFIL***********/

    /*** receive */
    for (i = 0; i < 16; i++) {
      (*filter)[0][phase & 1][i][phase >> 1] = flo[i];
      (*filter)[1][phase & 1][i][phase >> 1] = fhi[i];
    }

    pcm1 = calc_sample (filter, phase, pcm1); /*** receive */

    phase = (phase + 1) % 16;

    if (nch == 2) {
      /*** receive */
      for (i = 0; i < 16; i++) {
	(*filter2)[0][phase2 & 1][i][phase2 >> 1] = flo2[i];
	(*filter2)[1][phase2 & 1][i][phase2 >> 1] = fhi2[i];
      }
      pcm2 = calc_sample (filter2, phase2, pcm2); /*** receive */
      phase2 = (phase2 + 1) % 16;
    }
  }
}


/*
 * NAME:        synth->frame()
 * DESCRIPTION: perform PCM synthesis of frame subband samples
 */
void mad_synth_frame(struct mad_synth *synth, struct mad_frame const *frame)
{
  unsigned int nch, ns;
  nch = MAD_NCHANNELS(&frame->header);
  ns  = MAD_NSBSAMPLES(&frame->header);

  synth->pcm.samplerate = frame->header.samplerate;
  synth->pcm.channels   = nch;
  synth->pcm.length     = 32 * ns;

//PC: Replace pointer with actual function
  synth_full(synth, frame, nch, ns);

  synth->phase = (synth->phase + ns) % 16;
}

/*
 * NAME:	frame->decode()
 * DESCRIPTION:	decode a single frame from a bitstream
 */
int mad_frame_decode(struct mad_frame *frame, struct mad_stream *stream)
{
  frame->options = stream->options;


  if (!(frame->header.flags & MAD_FLAG_INCOMPLETE) &&
      mad_header_decode(&frame->header, stream) == -1)
    goto fail;
//	xil_printf("--------After mad_header decode ----- \n");


  /* audio_data() */

  frame->header.flags &= ~MAD_FLAG_INCOMPLETE;
  if (mad_layer_III(stream, frame) == -1) {
    if (!MAD_RECOVERABLE(stream->error))
      stream->next_frame = stream->this_frame;

    goto fail;
  }

//	xil_printf("--------After mad layer III ----- \n");

  if (frame->header.layer != MAD_LAYER_III) {
    struct mad_bitptr next_frame;

    mad_bit_init(&next_frame, stream->next_frame);

    //stream->anc_ptr    = stream->ptr;
	mymemcpy(&stream->anc_ptr, &stream->ptr, sizeof(struct mad_bitptr));

    stream->anc_bitlen = mad_bit_length(&stream->ptr, &next_frame);

    mad_bit_finish(&next_frame);
  }

  return 0;

 fail:
  stream->anc_bitlen = 0;
  return -1;
}

int mad_decode_synth_frame(struct mad_synth *synth,
                struct mad_frame const *frame, struct mad_stream *stream,
                void * error_data)
{
      //xil_printf("--------Before mad frame decode ----- \n");
      if (mad_frame_decode((struct mad_frame*)frame, stream) == -1) {
        if (!MAD_RECOVERABLE(stream->error))
          return -1;

        switch (error(error_data, stream, (struct mad_frame*)frame)) {
        case MAD_FLOW_IGNORE:
          break;
        default:
          return -1;
        }
      }
	  	    //xil_printf("--------After mad frame decode ----- \n");

      mad_synth_frame(synth, frame);
	  	    //xil_printf("--------After mad synth frame  ----- \n");
      //Remove this return and see that program doesn't 
      //work with optimization ON
      return 0;
}

int run_sync(struct mad_decoder *decoder, unsigned char *outfile)	
{

  void *error_data;
  int bad_last_frame = 0;
  struct mad_stream *stream;
  struct mad_frame *frame;
  struct mad_synth *synth;
  int result = 0;

  error_data = decoder->cb_data;

  stream = &decoder->sync->stream;
  frame  = &decoder->sync->frame;
  synth  = &decoder->sync->synth;
printf("Initializing stream\n");
  mad_stream_init(stream);
  mad_frame_init(frame);
  mad_synth_init(synth);

  mad_stream_options(stream, decoder->options);

  do {
    switch (input(decoder->cb_data, stream)) {
    case MAD_FLOW_STOP:
      goto done;
    case MAD_FLOW_BREAK:
      goto fail;
    case MAD_FLOW_IGNORE:
      continue;
    case MAD_FLOW_CONTINUE:
      break;
    };
#ifdef SC
int count=0;
printf("Decoding frame:      ");
#endif
    while (1) {
     if(mad_decode_synth_frame(synth, frame, stream, error_data) == -1) {
	if (!MAD_RECOVERABLE(stream->error))
	  break;

	switch (error(error_data, stream, frame)) {
	case MAD_FLOW_STOP:
	  goto done;
	case MAD_FLOW_BREAK:
	  goto fail;
	case MAD_FLOW_IGNORE:
	  break;
	case MAD_FLOW_CONTINUE:
	default:
	  continue;
	}
      }
      else
	bad_last_frame = 0;
#ifdef SC
printf("\b\b\b\b\b\b%03i   ",count++);
#endif
        switch (output(decoder->cb_data, &frame->header, 
				&synth->pcm, outfile)) {
        case MAD_FLOW_STOP:
          goto done;
        case MAD_FLOW_BREAK:
          goto fail;
        case MAD_FLOW_IGNORE:
        case MAD_FLOW_CONTINUE:
          break;
        }
    }
printf("\n");
  }
  while (stream->error == MAD_ERROR_BUFLEN);

 fail:
  result = -1;

 done:
printf("Closing stream\n");
  mad_synth_finish(synth);
  mad_frame_finish(frame);
  mad_stream_finish(stream);

  return result;
}

/* mad decoder */
int mad_decoder_run(unsigned char const *start, uln length, unsigned char * outfile)
{
  struct buffer buffer;
  struct mad_decoder decoder;
  int result;

  /* initialize our private message structure */

  buffer.start  = start;
  buffer.length = length;

//PC: Before anything, call the init function
  mad_decoder_init(&decoder, &buffer);
  decoder.sync = &decoder.syncobj;
  result = run_sync(&decoder, outfile);
  decoder.sync = 0;
  return result;
}
#ifndef SC
int main()
#else
int mp3_main()
#endif
{
  if (argc==1){
	printf("Filename missing.\n");
	exit(1);
  }
  void *fdm;
  int stream_length = MP3BYTES;
  unsigned char *goldfile;
  int bytesread;
    
#ifdef SOUND
  //SDL initialization
if( SDL_Init(SDL_INIT_TIMER | SDL_INIT_AUDIO ) <0 ) {
	printf("Unable to init SDL:%s\n",SDL_GetError());
	return 1;
}
        /* setup audio */
        SDL_AudioSpec *desired;

    /* Allocate a desired SDL_AudioSpec */
    desired = (SDL_AudioSpec *) malloc(sizeof(SDL_AudioSpec));
    
    /* choose a samplerate and audio-format */
    desired->freq = 22050;
    desired->format = AUDIO_S16LSB;
    desired->samples = 32768; 
    
    /* Our callback function */
    desired->callback=fill_audio;
    desired->userdata=NULL;

        desired->channels = 2;

        /* Open the audio device and start playing sound! */
        if ( SDL_OpenAudio(desired,NULL) < 0 ) {
                fprintf(stderr, "Unable to open audio: %s\n", SDL_GetError());
                exit(1);
        }
	SDL_PauseAudio(0); 
#endif
#ifdef VISUAL
  //initialize file for GNUPlot
  graph=fopen("graph.dat","w");
  fprintf(graph, "0 0.0\n");
  fflush(graph);
  graphPlot = popen("gnuplot -persist","w");
  fprintf(graphPlot, "set title \"PCM values\"\n");
  char temp[100];
  if (get_sc_time()==-1){
	  sprintf(temp, "set xlabel \"sample number \"\n");
  }else{
	  sprintf(temp, "set xlabel \"time [ns] \"\n");
  }
  fprintf(graphPlot, temp);
//  fprintf(graphPlot, "set xtics 0, 4e4\n");
//  fprintf(graphPlot, "set xrange [0:0.4e6]\n");
  fprintf(graphPlot, "set yrange [-20000:20000]\n");
  fprintf(graphPlot, "set border\n");
  fprintf(graphPlot, "set nogrid\n");
  fprintf(graphPlot, "set nokey\n");
  fprintf(graphPlot, "plot \"graph.dat\" w boxes\n");
  fflush(graphPlot);

#endif 
printf("Started decoding\n");
 
   goldfile = 0x20230000;
#ifndef SC
   // Initialize ICache
   microblaze_enable_icache ();
	// Initialize DCache
	microblaze_enable_dcache ();

   init();

   mad_decoder_run(instream, 5000, goldfile);
#else
FILE *infile;
FILE *outfile;

struct stat stat;
argv++;
  if (lstat(*argv, &stat) == -1 ||
      stat.st_size == 0)
    return 2;

//input file name
char *inname=*argv;
int begin=strlen(inname);
//get the base name
while(inname[begin]!='/'){
  begin--;
}
char myname[100];
int i;
int j=0;
for (i=begin+1;i<strlen(inname)-3;i++){
   myname[j++]=inname[i];
}

fdm = (void*) malloc((size_t)stat.st_size);
//printf("%i\n",(size_t)stat.st_size);
  if((infile = fopen(*argv, "rb")) == NULL)
  {
    printf("Could not open file to read \n");
    return 5;
  }
  //Read the file 
  if((bytesread = fread(fdm, 1, stat.st_size, infile)) != stat.st_size)
  {
    printf("read %d bytes instead of %d bytes\n",bytesread, stat.st_size);
    return 6;
  }

fclose(infile);
stream_length = stat.st_size;

argv++;
//path contains the output path
char *outpath=*argv;
char outputname[500];
sprintf(outputname,"%s/%sout",outpath,myname);
  if((outfile = fopen(outputname, "wb")) == NULL)
  {
    printf("Could not open file to write \n");
    return 5;
  }
mad_decoder_run(fdm, stream_length,outfile);
fclose(outfile);
#endif
printf("Decoding complete\n");
#ifdef SOUND
while(end==0){}
SDL_CloseAudio();
#endif
#ifdef SC
exit_simulation();
#else
exit(0);
#endif
#ifndef SC 
   WriteToGPOutputComplete(XPAR_LEDS_2BIT_BASEADDR);
#endif
  return 0;
}

