/*
 * libmad - MPEG audio decoder library
 * Copyright (C) 2000-2004 Underbit Technologies, Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * $Id: decoder.c,v 1.1 2008/11/04 03:05:17 yjahn Exp $
 */
#include <math.h>
#ifdef VISUAL
#include <stdio.h>
#define SDELAY 500
extern FILE *graph;
extern FILE *graphPlot;
int cont=0;
#endif
#ifdef SOUND
#include <SDL/SDL.h>
#include <SDL/SDL_main.h>
#include <alsa/asoundlib.h>

static int audio_len=873216;
Uint16 out[1300000];
Uint16 *audio_pos=out;
int end=0;
int counter=0;
int lastcount=0;
    /* The audio function callback takes the following parameters:
       stream:  A pointer to the audio buffer to be filled
       len:     The length (in bytes) of the audio buffer
    */
void fill_audio(void *udata, Uint8 *stream, int len)
    {
	int amount,total;
        // Only play if we have data left 
        if ( audio_len <= 0 ){
		end=1;
            return;
	}

	memcpy(stream,audio_pos,len);
        audio_pos += len/2;
        audio_len -= len/2;
	lastcount=counter;
    }
#endif
#ifdef SC
#include <stdio.h> //PC:
#include <sys/mman.h> //PC:
#include <unistd.h>
#include <sys/stat.h>
#include <stdlib.h> //PC:
#endif
# ifdef HAVE_CONFIG_H
#  include "config.h"
# endif

# include "global.h"

# ifdef HAVE_SYS_TYPES_H
#  include <sys/types.h>
# endif

# ifdef HAVE_SYS_WAIT_H
#  include <sys/wait.h>
# endif

# ifdef HAVE_UNISTD_H
#  include <unistd.h>
# endif

# ifdef HAVE_FCNTL_H
#  include <fcntl.h>
# endif

#ifdef DEBUG_INC_LIBS
# include <stdlib.h> //PC:
#endif

# ifdef HAVE_ERRNO_H
#  include <errno.h>
# endif

# include "stream.h"
# include "frame.h"
# include "synth.h"
# include "decoder.h"

#ifndef SC
#include "xutil.h"
#include "xgpio_l.h"
#include "xparameters.h"
#define  GOOD_DATA  1
#define  BAD_DATA   2
#define  ONBOARD
//#define  ONVP
#endif

#ifndef SC
void WriteToGPOutput(Xuint32 BaseAddress, int error) {
   int i=0, j=0;
   volatile int delay=0;
   int numTimes = 1;
 
   XGpio_mSetDataDirection(BaseAddress, 1, 0x00000000);   /* Set as outputs */
   while (numTimes > 0) {
      j = 1;
      for(i=0; i<1; i++) {
         XGpio_mSetDataReg(BaseAddress, 1, error);
         j = j << 1;
         for (delay=0; delay<10000; delay++) {
            ; //wait
         }
      }
      j = 0;
      j = ~j;
      for(i=0; i<1; i++) {
         XGpio_mSetDataReg(BaseAddress, 1, j);
         j = j << 1;
         for (delay=0; delay<10000; delay++) {
            ; //wait
         }
      }
      numTimes--;
   }
}

void WriteToGPOutputFaulty(Xuint32 BaseAddress) {

   XGpio_mSetDataDirection(BaseAddress, 1, 0x00000000);   /* Set as outputs */
   XGpio_mSetDataReg(BaseAddress, 1, BAD_DATA);
}
#endif

struct buffer {
  unsigned char const *start;
  uln length;
};
//extern int count;
int mad_decode_synth_frame(struct mad_synth *synth, struct mad_frame 
		const *frame, struct mad_stream *stream, void* error_data);


//PC: This is just for testing

#ifdef  DEBUG_INC_LIBS
#ifndef SC
enum mad_flow output(void *data,
                     struct mad_header const *header,
                     struct mad_pcm *pcm, unsigned char *outfile)
{
  unsigned int nchannels, nsamples;
  mad_fixed_t const *left_ch, *right_ch;
  //PC: 
  signed int temp_sample;

  /* pcm->samplerate contains the sampling frequency */

  nchannels = pcm->channels;
  nsamples  = pcm->length;
  left_ch   = pcm->samples[0];
  right_ch  = pcm->samples[1];

  while (nsamples--) {
    signed int sample;
	if (nsamples == 867) {
		// stop here
		int cvcv = 0;
		cvcv++;
    }
    /* output sample(s) in 16-bit signed little-endian PCM */
    sample = (*left_ch++);
#if 0
	xil_printf ("%d %d ", ((sample >> 0) & 0xff), 
				((sample >> 8) & 0xff));
#endif
	//WriteToGPOutput(XPAR_LEDS_2BIT_BASEADDR, 2);

/* instead of writing pcm, compare to golden */
//	count ++;
	if ((unsigned char)((sample >> 0) & 0xff) != (*outfile++)) {
		//xil_printf ("%d   Decoded = %d    Golden = %d\n", 
		//	count, (sample >> 0) & 0xff, GoldenSample[0]);
		#ifdef ONBOARD
		  WriteToGPOutput(XPAR_LEDS_2BIT_BASEADDR, BAD_DATA);
			WriteToGPOutputFaulty(XPAR_LEDS_2BIT_BASEADDR);
        #endif
		#ifdef ONVP
		  xil_printf("unmatched\n");
		#endif
    }
	else {
		#ifdef ONBOARD
		  WriteToGPOutput(XPAR_LEDS_2BIT_BASEADDR, GOOD_DATA);
        #endif
		#ifdef ONVP
		  //xil_printf("matched !!\n");
		#endif
    }
    
//	mfs_file_read(outfile, GoldenSample, 1);
//	count ++;
	if ((unsigned char)((sample >> 8) & 0xff) != (*outfile++)) {
		#ifdef ONBOARD
		  WriteToGPOutput(XPAR_LEDS_2BIT_BASEADDR, BAD_DATA);
			WriteToGPOutputFaulty(XPAR_LEDS_2BIT_BASEADDR);
        #endif
		#ifdef ONVP
		  xil_printf("unmatched\n");
		#endif
    }
	else {
		#ifdef ONBOARD
		  WriteToGPOutput(XPAR_LEDS_2BIT_BASEADDR, GOOD_DATA);
        #endif
		#ifdef ONVP
		  //xil_printf("matched !!\n");
		#endif
	}

    if (nchannels == 2) {
       sample = (*right_ch++);
#if 0
	   xil_printf ("%d %d ", ((sample >> 0) & 0xff), 
				((sample >> 8) & 0xff));
#endif

       /* instead of writing pcm, compare to golden */
//	   count ++;
	   if ((unsigned char)((sample >> 0) & 0xff) != (*outfile++)) {
		#ifdef ONBOARD
		  WriteToGPOutput(XPAR_LEDS_2BIT_BASEADDR, BAD_DATA);
			WriteToGPOutputFaulty(XPAR_LEDS_2BIT_BASEADDR);
        #endif
		#ifdef ONVP
		  xil_printf("unmatched\n");
		#endif
	   }
	   else {
		#ifdef ONBOARD
		  WriteToGPOutput(XPAR_LEDS_2BIT_BASEADDR, GOOD_DATA);
        #endif
		#ifdef ONVP
		  //xil_printf("matched !!\n");
		#endif
	   }

//	   count ++;
	   if ((unsigned char)((sample >> 8) & 0xff) != (*outfile++)) {
		#ifdef ONBOARD
		  WriteToGPOutput(XPAR_LEDS_2BIT_BASEADDR, BAD_DATA);
			WriteToGPOutputFaulty(XPAR_LEDS_2BIT_BASEADDR);
        #endif
		#ifdef ONVP
		  xil_printf("unmatched\n");
		#endif
	   }
	   else {
		#ifdef ONBOARD
		  WriteToGPOutput(XPAR_LEDS_2BIT_BASEADDR, GOOD_DATA);
        #endif
		#ifdef ONVP
		  //xil_printf("matched !!\n");
		#endif
	   }
    }
  }

  return MAD_FLOW_CONTINUE;
}
#else
enum mad_flow output(void *data,
                     struct mad_header const *header,
                     struct mad_pcm *pcm, FILE* outfile)
{
  unsigned int nchannels, nsamples;
  mad_fixed_t const *left_ch, *right_ch;
  //PC: 
  signed int temp_sample;

  /* pcm->samplerate contains the sampling frequency */

  nchannels = pcm->channels;
  nsamples  = pcm->length;
  left_ch   = pcm->samples[0];
  right_ch  = pcm->samples[1];

  while (nsamples--) {
    signed int sample;

    /* output sample(s) in 16-bit signed little-endian PCM */
#if 0
    sample = scale(*left_ch++);
#endif
    sample = (*left_ch++);
#ifdef SOUND
SDL_LockAudio();
#endif
#ifdef SC
    putc((sample >> 0) & 0xff, outfile);
    putc((sample >> 8) & 0xff, outfile);
#ifdef VISUAL
  cont++;
  if (cont%SDELAY==0) {
    if(get_sc_time()==-1)
	fprintf(graph, "%d %5d\n",cont,sample);
    else
	fprintf(graph, "%d %5d\n",get_sc_time(),sample);
  }
#endif
#endif
#ifdef SOUND
	out[counter++]=(Uint16) sample;
#endif 
    if (nchannels == 2) {
#if 0
      sample = scale(*right_ch++);
#endif
      sample = (*right_ch++);
#ifdef SC
      putc((sample >> 0) & 0xff, outfile);
      putc((sample >> 8) & 0xff, outfile);
#endif
#ifdef SOUND
	out[counter++]=(Uint16) sample;
#endif
    }
#ifdef VISUAL
  if (cont%SDELAY==0){
	fflush(graph);
	fprintf(graphPlot,"replot\n");
	fflush(graphPlot);
  }
#endif
#ifdef SOUND
SDL_UnlockAudio();
#endif
  }
  return MAD_FLOW_CONTINUE;
}
#endif
#endif

void mad_decoder_init(struct mad_decoder *decoder, void *data)
{
  decoder->mode         = -1;

  decoder->options      = 0;

  decoder->async.pid    = 0;
  decoder->async.inp     = -1;
  decoder->async.outp    = -1;

  decoder->sync         = 0;

  decoder->cb_data      = data;

}

enum mad_flow input(void *data,
		    struct mad_stream *stream)
{
  struct buffer *buffer = data;
  if (!buffer->length)
    return MAD_FLOW_STOP;

  mad_stream_buffer(stream, buffer->start, buffer->length);

  buffer->length = 0;
  return MAD_FLOW_CONTINUE;
}

enum mad_flow error(void *data,
                    struct mad_stream *stream,
                    struct mad_frame *frame)
{
  struct buffer *buffer = data;
  /* return MAD_FLOW_BREAK here to stop decoding (and propagate an error) */

  return MAD_FLOW_CONTINUE;
}

